#INCLUDE "dcdialog.CH"
#INCLUDE "appevent.CH"
#INCLUDE "commandBars.CH"
#INCLUDE "suite.CH"
#INCLUDE "taskpanel.CH"
#INCLUDE "shortcutbar.CH"
#INCLUDE "calendar.CH"
#INCLUDE "XCodeJock.CH"

#DEFINE ON .t.
#DEFINE OFF .f.

CLASS CJ_Parts

EXPORTED:
  VAR loadedIcons
  VAR gotFocus
  VAR lostFocus
  VAR anchorBlock
  VAR actionBlock
  VAR actionArray
  VAR lastIconIndex

INLINE METHOD Init

::loadedIcons := {}
::lastIconIndex := 0

RETURN self

* ---------

INLINE METHOD loadIcon( ncImage, nID, cDll, cResType )

LOCAL nHandle, aResFile, i, oImage,  oIcons

IF Valtype(nID) == 'N' .AND. AScan(::loadedIcons,{|a|a[1]==nID}) > 0
  RETURN nID
ENDIF

oIcons := ::getProperty("icons")

IF nID == NIL
  ::lastIconIndex++
  nID := ::lastIconIndex
ENDIF

IF Valtype(cDll) == 'C'
  nHandle := GetModuleHandleA(cDll) // Handle of DLL
ELSEIF Valtype(ncImage) == 'N'
  IF Empty(cResType) .AND. Empty(cDll)
    aResFile := DC_BitmapResourceFile()
    FOR i := 1 TO Len(aResFile)
      nHandle := aResFile[i]
      CJLoadIconFromResource ncImage HANDLE nHandle ID nID STATE xtpImageNormal PARENT oIcons
      oImage := oIcons:getImage(nID,32)
      IF oImage == nil
        CJLoadBitmapFromResource ncImage HANDLE nHandle ID nID STATE xtpImageNormal PARENT oIcons
        oImage := oIcons:getImage(nID,32)
      ENDIF
      IF Valtype(oImage) == 'O'
        AAdd(::loadedIcons,{nID,ncImage})
        RETURN nID
      ENDIF
    NEXT i
  ENDIF
  IF Empty(oImage)
    nHandle := GetModuleHandleA(0) // Handle of EXE
  ENDIF
ENDIF

IF Valtype(nHandle) = 'N' .AND. Empty(oImage)
  DEFAULT nID := ncImage
  CJLoadIconFromResource ncImage HANDLE nHandle ID nID STATE xtpImageNormal PARENT oIcons
  AAdd(::loadedIcons,{nID,ncImage})
ELSEIF Valtype(ncImage) == 'C'
  IF '.ICO' $ Upper(ncImage)
    CJLoadIcon ncImage ID nID STATE xtpImageNormal PARENT oIcons
    AAdd(::loadedIcons,{nID,ncImage})
  ELSEIF '.BMP' $ Upper(ncImage)
    CJLoadBitmap ncImage ID nID STATE xtpImageNormal PARENT oIcons
    AAdd(::loadedIcons,{nID,ncImage})
  ENDIF
ENDIF

RETURN nID

* ------------

INLINE METHOD SetColor( aGetListItem )

LOCAL aColor

aColor := aGetListItem[aGETLIST_COLOR]
DEFAULT aColor := {}
ASize(aColor,2)
IF Valtype(aColor[1]) $ 'NA'
  ::setProperty('foreColor',CJ_Color(aColor[1],.f.))
ENDIF
IF Valtype(aColor[2]) $ 'NA'
  ::setProperty('backColor',CJ_Color(aColor[2],.f.))
ENDIF

RETURN nil

* ------------

INLINE METHOD AddListBoxItems( aItems )

LOCAL i

FOR i := 1 TO Len(aItems)
  ::AddItem( aItems[i])
NEXT

RETURN nil

* ------------

INLINE METHOD Action( nIndex )

LOCAL nFound

IF Valtype(nIndex) == 'N' .AND. (nFound := AScan(::actionArray,{|a|a[1]==nIndex})) > 0
  Eval(::actionArray[nFound,2],self)
ELSEIF Valtype(::actionBlock) == 'B'
  Eval(::actionBlock,self)
ENDIF

RETURN self

ENDCLASS

* ========================

CLASS CJ_CheckBox FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oXOptions )
::clsid := 'CodeJock.CheckBox' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, @oXOptions )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions, cFont, bAction, cCaption

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,7)

DEFAULT aOptions[1] := xtpAppearanceUltraFlat, ;
        aOptions[2] := .f., ;
        aOptions[3] := .f., ;
        aOptions[4] := xtpAlignLeft, ;
        aOptions[5] := .f., ;
        aOptions[5] := .f., ;
        aOptions[6] := .f.

::appearance := aOptions[1]
::transparent := aOptions[2]
::enableMarkup := aOptions[3]
::textAlignment := aOptions[4]
::useVisualStyle := aOptions[5]
::multiLine := aOptions[6]
::rightToLeft := aOptions[7]

::setColor(aGetListItem)

cFont := aGetListItem[cGETLIST_FONT]
// IF !Empty(cFont) ; ::setProperty("font",CJ_Font(cFont)) ; ENDIF  // << locks up app

cCaption := aGetListItem[cGETLIST_CAPTION]
IF !Empty(cCaption) ; ::caption := cCaption ; ENDIF

::anchorBlock := aGetListItem[bGETLIST_VAR]
::value := IIF(Eval(::anchorBlock),xtpChecked,xtpUnchecked)

::actionBlock := aGetListItem[bGETLIST_ACTION]

::subscribeEvent('click', {|x|Eval(::anchorBlock,::value==xtpChecked),::Action()})

RETURN self

ENDCLASS

* ========================

CLASS CJ_TreeView FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oXOptions )
::clsid := 'CodeJock.TreeView' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, @oXOptions )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions, cFont

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,22)

DEFAULT aOptions[1] := xtpAppearanceUltraFlat, ;
        aOptions[2] := .f., ;
        aOptions[4] := .f., ;
        aOptions[5] := .f., ;
        aOptions[6] := .f., ;
        aOptions[7] := .f., ;
        aOptions[10] := xtpTreeViewLabelAutomatic, ;
        aOptions[12] := .f., ;
        aOptions[13] := .f., ;
        aOptions[14] := .f., ;
        aOptions[17] := .f., ;
        aOptions[18] := .f., ;
        aOptions[19] := .f., ;
        aOptions[20] := .f., ;
        aOptions[21] := .f., ;
        aOptions[22] := xtpTreeViewShowLines

::appearance := aOptions[1]
::checkBoxes := aOptions[2]
::enableMarkup := aOptions[4]
::fullRowSelect := aOptions[5]
::hideSelection := aOptions[6]
::hotTracking := aOptions[7]
IF Valtype(aOptions[8]) == 'N' ; ::iconSize := aOptions[8] ; ENDIF
IF Valtype(aOptions[9]) == 'N' ; ::indentation := aOptions[9] ; ENDIF
::labelEdit := aOptions[10]
IF Valtype(aOptions[11]) == 'C' ; ::pathSeparator := aOptions[11] ; ENDIF
::rightToLeft := aOptions[12]
::rightToLeftReading := aOptions[13]
::scroll := aOptions[14]

IF !Empty(aOptions[15])
  ::setProperty("selectionForeColor",CJ_Color(aOptions[15],.f.))
ENDIF

IF !Empty(aOptions[16])
  ::setProperty("selectionBackColor",CJ_Color(aOptions[16],.f.))
ENDIF

::showBorder := aOptions[17]
::showPlusMinus := aOptions[18]
::singleSel := aOptions[19]
::sorted := aOptions[20]
::useVisualStyle := aOptions[21]
::showLines := aOptions[22]

cFont := aGetListItem[cGETLIST_FONT]
IF !Empty(cFont) ; ::setProperty("font",CJ_Font(cFont)) ; ENDIF

::setColor(aGetListItem)

RETURN self

ENDCLASS

* ========================

CLASS CJ_ProgressBar FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

::clsid := 'CodeJock.ProgressBar' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )
LOCAL aGetListItem, aOptions

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,22)

DEFAULT aOptions[1] := xtpAppearanceUltraFlat, ;
        aOptions[3] := .f., ;
        aOptions[10] := .f.

::appearance := aOptions[1]
IF !Empty(aOptions[2]) ; ::setProperty("barColor",CJ_Color(aOptions[2],.f.)) ; ENDIF
::flatStyle := aOptions[3]
IF !Empty(aOptions[4]) ; ::marqueeDelay := aOptions[4] ; ENDIF
IF !Empty(aOptions[5]) ; ::min := aOptions[5] ; ENDIF
IF !Empty(aOptions[6]) ; ::max := aOptions[6] ; ENDIF
IF !Empty(aOptions[7]) ; ::setProperty('scrolling',aOptions[7]) ; ENDIF
IF !Empty(aOptions[8]) ; ::text := aOptions[8] ; ENDIF
IF !Empty(aOptions[9]) ; ::orientation := aOptions[9] ; ENDIF
::useVisualStyle := aOptions[10]
IF !Empty(aOptions[11]) ; ::value := aOptions[11] ; ENDIF

::setColor(aGetListItem)

RETURN self

ENDCLASS

* ========================

CLASS CJ_RadioButton FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

CLASS VAR checkValue
CLASS VAR radioGroupID

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::radioGroupID := 'RadioGroup1'
::clsid := 'CodeJock.RadioButton' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions, cFont, cCaption

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,12)

DEFAULT aOptions[1] := xtpAppearanceUltraFlat, ;
        aOptions[2] := .f., ;
        aOptions[3] := .f., ;
        aOptions[4] :=  xtpAlignLeft, ;
        aOptions[6] := .f., ;
        aOptions[9] := .f., ;
        aOptions[10] := .f.

::appearance := aOptions[1]
::transparent := aOptions[2]
::enableMarkup := aOptions[3]
IF Valtype(aOptions[4]) == 'N' ; ::textAlignment := aOptions[4] ; ENDIF
::rightToLeft := aOptions[6]
::radioGroupID := aOptions[7]
IF !(aOptions[8] == NIL) ; ::checkValue := aOptions[8] ; ENDIF
::setProperty("multiLine",aOptions[9])
::drawFocusRect := aOptions[10]

::setColor(aGetListItem)

cCaption := aGetListItem[cGETLIST_CAPTION]
IF !Empty(cCaption) ; ::caption := cCaption ; ENDIF

cFont := aGetListItem[cGETLIST_FONT]
// IF !Empty(cFont) ; ::setProperty("font",CJ_Font(cFont)) ; ENDIF

::anchorBlock := aGetListItem[bGETLIST_VAR]
::checkValue := Eval(::anchorBlock)

::actionBlock := aGetListItem[bGETLIST_ACTION]

::subscribeEvent('click', {|x|Eval(::anchorBlock,::checkValue),::Action()})

RETURN self

ENDCLASS

* ========================

CLASS CJ_MonthCalendar FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oXOptions )
::clsid := 'CodeJock.MonthCalendar' + CJ_Version()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, @oXOptions )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions, cFont

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,16)

DEFAULT aOptions[1] := .f., ;
        aOptions[9] := .f., ;
        aOptions[12] := .f., ;
        aOptions[13] := .f.

::autoSize := aOptions[1]
IF Valtype(aOptions[2]) == 'N' ; ::day := aOptions[2] ; ENDIF
IF Valtype(aOptions[3]) == 'N' ; ::maxDate := aOptions[3] ; ENDIF
IF Valtype(aOptions[4]) == 'N' ; ::minDate := aOptions[4] ; ENDIF
IF Valtype(aOptions[5]) == 'N' ; ::maxSelCount := aOptions[5] ; ENDIF
IF Valtype(aOptions[6]) == 'N' ; ::month := aOptions[6] ; ENDIF
IF Valtype(aOptions[7]) == 'N' ; ::monthColumns := aOptions[7] ; ENDIF
IF Valtype(aOptions[8]) == 'N' ; ::monthRows := aOptions[8] ; ENDIF
::multiSelect := aOptions[9]
IF Valtype(aOptions[10]) == 'N' ; ::selStart := aOptions[10] ; ENDIF
IF Valtype(aOptions[11]) == 'N' ; ::selEnd := aOptions[11] ; ENDIF
::showToday := aOptions[12]
::showWeekNumbers := aOptions[13]
IF Valtype(aOptions[14]) == 'N' ; ::startOfWeek := aOptions[14] ; ENDIF
IF Valtype(aOptions[15]) == 'D' ; ::value := aOptions[15] ; ENDIF
IF Valtype(aOptions[16]) == 'N' ; ::year := aOptions[16] ; ENDIF

cFont := aGetListItem[cGETLIST_FONT]
// IF Valtype(cFont) == 'C' ; ::setProperty("font",CJ_Font(cFont)) ; ENDIF

RETURN self

ENDCLASS

* ========================

CLASS CJ_ComboBox FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.ComboBox' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )
LOCAL aGetListItem, aOptions, cFont

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,17)

DEFAULT aOptions[1] := xtpAppearanceUltraFlat, ;
        aOptions[2] := .f., ;
        aOptions[3] := .f., ;
        aOptions[5] := xtpComboDropDown, ;
        aOptions[6] := .f., ;
        aOptions[12] := 1, ;
        aOptions[13] := .f., ;
        aOptions[14] := .f., ;
        aOptions[15] := .f., ;
        aOptions[16] := .f., ;
        aOptions[17] := {}

::appearance := aOptions[1]
::enableMarkup := aOptions[2]
::autoComplete := aOptions[3]
IF !Empty(aOptions[4])
  ::text := aOptions[4]
ENDIF
::style := aOptions[5]
::flatStyle := aOptions[6]
IF !Empty(aOptions[7])
  ::dropDownItemCount := aOptions[7]
ENDIF
IF !Empty(aOptions[8])
  ::dropDownWidth := aOptions[8]
ENDIF
IF !Empty(aOptions[9])
  ::selLength := aOptions[9]
ENDIF
IF !Empty(aOptions[10])
  ::selStart := aOptions[10]
ENDIF
IF !Empty(aOptions[11])
  ::selText := aOptions[11]
ENDIF
::topIndex := aOptions[12]
::droppedState := aOptions[13]
::sorted := aOptions[14]
::rightToLeft := aOptions[15]
::locked := aOptions[16]

::setColor(aGetListItem)

cFont := aGetListItem[cGETLIST_FONT]
IF !Empty(cFont)
  ::setProperty('font',CJ_Font(cFont))
ENDIF

::AddListBoxItems(aOptions[17])

::anchorBlock := aGetListItem[bGETLIST_VAR]
::text := Eval(::anchorBlock)

::actionBlock := aGetListItem[bGETLIST_ACTION]

::subscribeEvent('change', {|x|Eval(::anchorBlock,::text),IIF(Empty(x),::Action(),nil)})

::killInputFocus := {|a,b,o|::fireEvent("change",.t.)}

RETURN self

ENDCLASS

* ========================

CLASS CJ_FlatEdit FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.FlatEdit' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )
LOCAL aGetListItem, aOptions, cFont

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,19)

DEFAULT aOptions[1] := xtpAppearanceUltraFlat, ;
        aOptions[2] := .f., ;
        aOptions[3] := xtpEditAlignLeft, ;
        aOptions[5] := .f., ;
        aOptions[9] := .f., ;
        aOptions[10] := .f., ;
        aOptions[12] := .f., ;
        aOptions[15] := xtpEditScrollBarsNone, ;
        aOptions[16] := .f., ;
        aOptions[17] := .f., ;
        aOptions[18] := .f.

::appearance := aOptions[1]
::hideSelection := aOptions[2]
::alignment := aOptions[3]
IF Valtype(aOptions[4]) == 'C' ; ::text := aOptions[4] ; ENDIF
::flatStyle := aOptions[5]
IF Valtype(aOptions[6]) == 'N' ; ::selLength := aOptions[6] ; ENDIF
IF Valtype(aOptions[7]) == 'N' ; ::selStart := aOptions[7] ; ENDIF
IF Valtype(aOptions[8]) == 'C' ; ::selText := aOptions[8] ; ENDIF
::rightToLeft := aOptions[9]
::locked := aOptions[10]
IF Valtype(aOptions[11]) == 'C' ; ::maskedText := aOptions[11] ; ENDIF
::setProperty("multiLine",aOptions[12])
IF Valtype(aOptions[13]) == 'C' ; ::passwordChar := aOptions[13] ; ENDIF
IF Valtype(aOptions[14]) == 'C' ; ::pattern := aOptions[14] ; ENDIF
::setProperty("scrollBars",aOptions[15])
::showBorder := aOptions[16]
::transparent := aOptions[17]
::useVisualStyle := aOptions[18]
IF Valtype(aOptions[19]) == 'N' ; ::max := aOptions[19] ; ENDIF

::setColor(aGetListItem)

cFont := aGetListItem[cGETLIST_CAPTION]
IF Valtype(cFont) == 'C' ; ::setProperty("font",CJ_Font(cFont)) ; ENDIF

::anchorBlock := aGetListItem[bGETLIST_VAR]
::text := Eval(::anchorBlock)

::actionBlock := aGetListItem[bGETLIST_ACTION]

::subscribeEvent('change', {|x|Eval(::anchorBlock,::text),IIF(Empty(x),::Action(),nil)})

RETURN self

ENDCLASS

* ========================

CLASS CJ_HexEdit FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.HexEdit' + CJ_Version()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )
LOCAL aGetListItem, aOptions

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,11)

DEFAULT aOptions[1] := xtpAppearanceUltraFlat, ;
        aOptions[2] := .f., ;
        aOptions[3] := .f., ;
        aOptions[5] := .f., ;
        aOptions[6] := .f., ;
        aOptions[7] := .f., ;
        aOptions[8] := .f., ;
        aOptions[11] := .f.

::appearance := aOptions[1]
::showBorder := aOptions[2]
::useVisualStyle := aOptions[3]
IF Valtype(aOptions[4]) == 'N' ; ::length := aOptions[4] ; ENDIF
::locked := aOptions[5]
::showAddress := aOptions[6]
::showAscii := aOptions[7]
::showHex := aOptions[8]
IF Valtype(aOptions[9]) == 'N' ; ::bytePerRow := aOptions[9] ; ENDIF
IF Valtype(aOptions[10]) == 'N' ; ::maxLength := aOptions[10] ; ENDIF
::wideAddress := aOptions[11]

::setColor(aGetListItem)

RETURN self

ENDCLASS

* ========================

CLASS CJ_CalendarControl FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

VAR calId


INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.CalendarControl' + CJ_Version()
::license := CJ_LicenseCalendar()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,11)

DEFAULT aOptions[1] := .f., ;
        aOptions[2] := .f., ;
        aOptions[3] := .f., ;
        aOptions[4] := .f., ;
        aOptions[5] := .f., ;
        aOptions[6] := .f., ;
        aOptions[7] := .f., ;
        aOptions[8] := .f., ;
        aOptions[9] := xtpCalendarThemeOffice2000, ;
        aOptions[10] := .f., ;
        aOptions[11] := xtpCalendarDayView

::markupEnabled := aOptions[1]
::rightToLeft := aOptions[2]
::showCaptionBar := aOptions[3]
::showCaptionBarDateLabel := aOptions[4]
// ::showCaptionBarExpandButton := aOptions[5]
::showCaptionBarScrollDateButtons := aOptions[6]
::showCaptionBarSwitchViewButtons := aOptions[7]
::showTimeLineButton := aOptions[8]
::visualTheme := aOptions[9]
::useMultiColumnWeekMode := aOptions[10]
::viewType := aOptions[11]

RETURN self

ENDCLASS

* ========================

CLASS CJ_CalendarCaptionBar FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.CalendarCaptionBar' + CJ_Version()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,16)

DEFAULT aOptions[8] := .f., ;
        aOptions[11] := .f., ;
        aOptions[12] := .f., ;
        aOptions[13] := .f., ;
        aOptions[14] := .f., ;
        aOptions[15] := .f., ;
        aOptions[16] := xtpCalendarThemeOffice2000

IF !Empty(aOptions[1]) ; ::setProperty('backgroundcolor',CJ_Color(aOptions[1],.f.)) ; ENDIF
IF !Empty(aOptions[2]) ; ::setProperty('bordercolor',CJ_Color(aOptions[2],.f.)) ; ENDIF
IF Valtype(aOptions[3]) == 'N' ; ::borderWidthBottom := aOptions[3] ; ENDIF
IF Valtype(aOptions[4]) == 'N' ; ::borderWidthLeft := aOptions[4] ; ENDIF
IF Valtype(aOptions[5]) == 'N' ; ::borderWidthRight := aOptions[5] ; ENDIF
IF Valtype(aOptions[6]) == 'N' ; ::borderWidthTop := aOptions[6] ; ENDIF
IF Valtype(aOptions[7]) == 'O' ; ::calendar := aOptions[7] ; ENDIF
::expandButtonChecked := aOptions[8]
IF Valtype(aOptions[9]) == 'O' ; ::minHeight := aOptions[9] ; ENDIF
IF Valtype(aOptions[10]) == 'O' ; ::minWidth := aOptions[10] ; ENDIF
::showDateLabel := aOptions[11]
::showExpandButton := aOptions[12]
::showScrollDateButtons := aOptions[13]
::showSwitchViewButtons := aOptions[14]
// ::showTimelineButton := aOptions[15]
::visualTheme := aOptions[16]

RETURN self

ENDCLASS

* ========================

CLASS CJ_DatePicker FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oXOptions )
::clsid := 'CodeJock.DatePicker' + CJ_Version()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, @oXOptions )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,24)

DEFAULT aOptions[1] := .f., ;
        aOptions[2] := .f., ;
        aOptions[4] := .f., ;
        aOptions[6] := .f., ;
        aOptions[7] := xtpDatePickerBorderNone, ;
        aOptions[12] := .f., ;
        aOptions[15] := .f., ;
        aOptions[16] := .f., ;
        aOptions[18] := .f., ;
        aOptions[19] := .f., ;
        aOptions[20] := .f., ;
        aOptions[21] := .f., ;
        aOptions[22] := 'None', ;
        aOptions[23] := 'Today', ;
        aOptions[24] := xtpCalendarThemeOffice2000

::autoSize := aOptions[1]
::askDayMetrics := aOptions[2]
IF !Empty(aOptions[3]) ; ::boldDaysIdleStepTime := aOptions[3] ; ENDIF
::boldDaysOnIdle := aOptions[4]
IF !Empty(aOptions[5]) ; ::boldDaysPerIdleStep := aOptions[5] ; ENDIF
::boldDaysWithEvents := aOptions[6]
::borderStyle := aOptions[7]
IF !Empty(aOptions[8]) ; ::columnCount := aOptions[7] ; ENDIF
IF !Empty(aOptions[8]) ; ::rowCount := aOptions[8] ; ENDIF
IF !Empty(aOptions[9]) ; ::firstDayOfWeek := aOptions[9] ; ENDIF
IF !Empty(aOptions[10]) ; ::firstVisibleDay := aOptions[10] ; ENDIF
IF !Empty(aOptions[11]) ; ::firstWeekOfYearDays := aOptions[11] ; ENDIF
::highlightToday := aOptions[12]
IF !Empty(aOptions[13]) ; ::lastVisibleDay := aOptions[13] ; ENDIF
IF !Empty(aOptions[14]) ; ::monthDelta := aOptions[14] ; ENDIF
::multiSelectionMode := aOptions[15]
::rightToLeft := aOptions[16]
IF !Empty(aOptions[17]) ; ::maxSelectionCount := aOptions[17] ; ENDIF
::showTodayButton := aOptions[18]
::showNoneButton := aOptions[19]
::showNonMonthDays := aOptions[20]
::showWeekNumbers := aOptions[21]
::textNoneButton := aOptions[22]
::textTodayButton := aOptions[23]
::visualTheme := aOptions[24]

RETURN self

ENDCLASS

* ========================

CLASS CJ_ImageManager FROM XbpActiveXControl

EXPORTED:

INLINE METHOD Init()
::XbpActiveXControl:init()
::clsid := 'CodeJock.ImageManager' + CJ_Version()
RETURN self

INLINE METHOD Create()
::XbpActiveXControl:create()
RETURN self

ENDCLASS

* ========================

CLASS CJ_ColorPicker FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.ColorPicker' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions, cCaption, cFont, bAction

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,9)

DEFAULT aOptions[1] := xtpAppearanceUltraFlat, ;
        aOptions[2] := .f., ;
        aOptions[3] := .f., ;
        aOptions[4] := .f., ;
        aOptions[7] := .f.

::appearance := aOptions[1]
::showAutomaticColor := aOptions[2]
::showMoreColors := aOptions[3]
::flatStyle := aOptions[4]
IF !Empty(aOptions[5])
  ::setProperty("selectedColor",CJ_Color(aOptions[5],.f.))
ENDIF
IF !Empty(aOptions[6])
  ::setProperty("defaultColor",CJ_Color(aOptions[6],.f.))
ENDIF
::useVisualStyle := aOptions[7]

cCaption := aGetListItem[cGETLIST_CAPTION]
IF !Empty(cCaption)
  ::caption := cCaption
ENDIF

cFont := aGetListItem[cGETLIST_FONT]
IF !Empty(cFont)
  // ::setProperty('font',CJ_Font(cFont)) // << locks up app
ENDIF

bAction := aGetListItem[bGETLIST_ACTION]
IF Valtype(bAction) == 'B'
  ::subscribeEvent("click",bAction)
ENDIF

RETURN self

ENDCLASS

* ========================

CLASS CJ_Label FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.Label' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )

RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions, cFont, cCaption
LOCAL lReset := .F.

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,9)

DEFAULT aOptions[1] := .f., ;
        aOptions[2] := .f., ;
        aOptions[3] := xtpAlignLeft, ;
        aOptions[4] := .f., ;
        aOptions[5] := .f., ;
        aOptions[6] := .f., ;
        aOptions[7] := .f., ;
        aOptions[8] := .f.

::enableMarkup := aOptions[1]
::rightToLeft := aOptions[2]
::alignment := aOptions[3]
::transparent := aOptions[4]
::wordWrap := aOptions[5]
::autoSize := aOptions[6]
::useMnemonic := aOptions[7]
::autoellipsis := aOptions[8]

::setColor(aGetListItem)

cCaption := aGetListItem[cGETLIST_CAPTION]
IF !Empty(cCaption)
  ::caption := cCaption
ENDIF

IF !Empty(aOptions[9])
  // $ALASKA: Assigning icon to :Icon has no effect
  IF ValType(aOptions[9]) == "O"
     aOptions[9]:UseMarshalling := .F.
     lReset := .T.
  ENDIF
  ::setProperty('icon',aOptions[9])
  // $ALASKA: Assigning icon to :Icon has no effect
  IF lReset
     aOptions[9]:UseMarshalling := .T.
  ENDIF

ENDIF

cFont := aGetListItem[cGETLIST_FONT]
IF !Empty(cFont)
 // ::setProperty('font',CJ_Font(cFont)) // << locks up app
ENDIF

RETURN nil

ENDCLASS

* ========================

CLASS CJ_TaskPanel FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.TaskPanel' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )

AAdd(oGetList:userEvents, { xbeP_User+12345, {|mp1|Eval(mp1)}} )
::CJ_Parts:init()

RETURN self

* ----------

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions, cFont, cCaption

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,17)

DEFAULT aOptions[1] := xtpTaskPanelHighlightDefault, ;
        aOptions[2] := xtpTaskItemLayoutDefault, ;
        aOptions[3] := xtpTaskPanelThemeNativeWinXP, ;
        aOptions[4] := .f., ;
        aOptions[5] := xtpTaskPanelAnimationNo, ;
        aOptions[6] := xtpTaskPanelBehaviourExplorer, ;
        aOptions[7] := xtpBorderNone, ;
        aOptions[9] := .f., ;
        aOptions[10] := .f., ;
        aOptions[11] := .f., ;
        aOptions[14] := .f., ;
        aOptions[15] := .f., ;
        aOptions[16] := .f., ;
        aOptions[17] := .f.

::hotTrackStyle := aOptions[1]
::itemLayout := aOptions[2]
::visualTheme := aOptions[3]
::enableMarkup := aOptions[4]
::animation := aOptions[5]
::behaviour := aOptions[6]
::borderStyle := aOptions[7]
IF Valtype(aOptions[8]) == 'N'
  ::columnWidth := aOptions[8]
ENDIF
::drawFocusRect := aOptions[9]
::enableAnimation := aOptions[10]
::expandable := aOptions[11]

IF !Empty(aOptions[12])
  ::setProperty('captionfont',CJ_Font(aOptions[12]))
ENDIF

IF !Empty(aOptions[13])
  ::setProperty('itemsfont',CJ_Font(aOptions[13]))
ENDIF
::multiColumn := aOptions[14]
::rightToLeft := aOptions[15]
::selectItemOnFocus := aOptions[16]
::singleSelection := aOptions[17]

::subscribeEvent('itemClick', {||::Action(::focusedItem:id)})

::loadedIcons := {}

RETURN self

* ----------

INLINE METHOD AddAction( aAction )

LOCAL bAction

IF Valtype(aAction)=='A' .AND. Valtype(aAction[1])=='N' .AND. Valtype(aAction[2]) == 'B'
  bAction := aAction[2]
  aAction[2] := {||PostAppEvent(xbeP_User+12345,bAction,,self)}
  AAdd( ::actionArray, aAction )
ENDIF

RETURN self

ENDCLASS

* ========================

CLASS CJ_GroupBox FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.GroupBox' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions, cFont, cCaption, aColor

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,4)

DEFAULT aOptions[1] := xtpAppearanceUltraFlat, ;
        aOptions[2] := .f., ;
        aOptions[3] := .f., ;
        aOptions[4] := .f.

cFont := aGetListItem[cGETLIST_FONT]
IF !Empty(cFont)
  // ::setProperty('font',CJ_Font(cFont)) // << locks up app
ENDIF

::appearance := aOptions[1]
::rightToLeft := aOptions[3]
::useVisualStyle := aOptions[2]
::transparent := aOptions[4]

cCaption := aGetListItem[cGETLIST_CAPTION]
IF !Empty(cCaption)
  ::caption := cCaption
ENDIF

::setColor( aGetListItem )

RETURN self

ENDCLASS

* ========================

CLASS CJ_ListBox FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.ListBox' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions, cFont, cCaption, aColor

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,11)

DEFAULT aOptions[1] := xtpAppearanceUltraFlat, ;
        aOptions[2] := xtpListStandard, ;
        aOptions[3] := {}, ;
        aOptions[4] := xtpListMultiSelectNone, ;
        aOptions[5] := .f., ;
        aoptions[6] := .f., ;
        aOptions[7] := .f., ;
        aOptions[8] := .f., ;
        aOptions[10] := .f.

::appearance := aOptions[1]
::style := aOptions[2]
::multiSelect := aOptions[4]
::flatStyle := aOptions[5]
::enableMarkup := aOptions[6]
::showBorder := aOptions[7]
::sorted := aOptions[8]
::rightToLeft := aOptions[10]
::setColor(aGetListItem)
IF !Empty(aOptions[9])
  ::columnWidth := aOptions[9]
ENDIF

cFont := aGetListItem[cGETLIST_FONT]
IF !Empty(cFont)
  ::setProperty("font",CJ_Font(cFont))
ENDIF

aColor := aGetListItem[xGETLIST_OPTIONS4]
DEFAULT aColor := {}
ASize(aColor,2)
IF Valtype(aColor[1]) $ 'NA'
  ::setProperty('selectionForeColor',CJ_Color(aColor[1],.f.))
ENDIF
IF Valtype(aColor[2]) $ 'NA'
  ::setProperty('selectionBackColor',CJ_Color(aColor[2],.f.))
ENDIF

cCaption := aGetListItem[cGETLIST_CAPTION]
IF !Empty(cCaption)
  ::text := cCaption
ENDIF

IF !Empty(aOptions[11])
  ::topIndex := aOptions[11]
ENDIF

::addListBoxItems( aOptions[3] )

RETURN self

ENDCLASS

* ========================

CLASS CJ_ListView FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

VAR itemSelected

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.ListView' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions, cFont, cCaption, aColor
LOCAL i, j, oItem, oListItems, cCell, aItems

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,26)

DEFAULT aOptions[1] := xtpAppearanceUltraFlat, ;
        aOptions[2] := xtpListViewArrangeAutoLeft, ;
        aOptions[3] := {}, ;
        aOptions[4] := 16, ;
        aOptions[5] := 0, ;
        aOptions[6] := xtpListViewLabelAutomatic, ;
        aOptions[7] := 0, ;
        aOptions[8] := xtpListViewReport, ;
        aOptions[9] := .f., ;
        aOptions[10] := .f., ;
        aOptions[11] := .f., ;
        aOptions[12] := .f., ;
        aOptions[13] := .f., ;
        aOptions[14] := .f., ;
        aOptions[15] := .f., ;
        aOptions[16] := .f., ;
        aOptions[17] := .f., ;
        aOptions[18] := .f., ;
        aOptions[19] := .f., ;
        aOptions[20] := .f., ;
        aOptions[21] := .f., ;
        aOptions[22] := .f., ;
        aOptions[23] := .f.

IF Valtype(aOptions[26]) == 'B'
  Eval(aOptions[26],self) // Load Header Icons
ENDIF

IF Valtype(aOptions[25]) == 'B'
  Eval(aOptions[25],self) // Load Data Icons
ENDIF

IF Valtype(aOptions[24]) == 'B'
  Eval(aOptions[24],self) // Add Headers
ENDIF

aItems := aOptions[3]
IF !Empty(aItems)
  oListItems := ::ListItems
  FOR i := 1 TO Len(aItems)
    oItem := oListItems:Add(0,'Item' + Alltrim(Str(i)), aItems[i,1])
    FOR j := 2 TO Len(aItems[i])
      cCell := 'Cell_'+Alltrim(Str(i))+'_'+Alltrim(Str(j))
      oItem:ListSubItems:Add(j-1,cCell,aItems[i,j])
    NEXT i
  NEXT j
ENDIF

::appearance := aOptions[1]
::arrange := aOptions[2]
::iconSize := aOptions[4]
::sortOrder := aOptions[5]
::labelEdit := aOptions[6]
::sortKey := aOptions[7]
::multiSelect := aOptions[9]
::flatScrollBar := aOptions[10]
::fullRowSelect := aOptions[11]
::gridLines := aOptions[12]
::allowColumnReorder := aOptions[13]
::hideColumnHeaders := aOptions[14]
::hideSelection := aOptions[15]
::hotTracking := aOptions[16]
::hoverSelection := aOptions[17]
::showBorder := aOptions[18]
::sorted := aOptions[19]
::checkboxes := aOptions[20]
::labelWrap := aOptions[21]
::rightToLeft := aOptions[22]
::useVisualStyle := aOptions[23]

::setColor(aGetListItem)

cFont := aGetListItem[cGETLIST_FONT]
IF !Empty(cFont)
  ::setProperty("font",CJ_Font(cFont))
ENDIF

::view := aOptions[8]

RETURN self

INLINE METHOD GetData()
LOCAL aItem
LOCAL nKey := ::SelectedItem:Index
aItem := ::ListItems:Item(nKey):Text

RETURN {aItem}

INLINE METHOD itemSelected()
IF !EMPTY(::itemSelected)
  EVAL(::itemSelected,NIL,NIL,Self)
ENDIF

RETURN self

ENDCLASS

* ========================

CLASS CJ_Slider FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oXOptions )
::clsid := 'CodeJock.Slider' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, @oXOptions )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,12)

DEFAULT aOptions[3] := xtpSliderHorizontal, ;
        aOptions[4] := .f., ;
        aOptions[5] := .f., ;
        aOptions[11] := xtpSliderBottomRight

IF Valtype(aOptions[1]) == 'N' ; ::min := aOptions[1] ; ENDIF
IF Valtype(aOptions[2]) == 'N' ; ::max := aOptions[2] ; ENDIF
::orientation := aOptions[3]
::showToolTips := aOptions[4]
::selectRange := aOptions[5]
IF Valtype(aOptions[6]) == 'N' ; ::smallChange := aOptions[6] ; ENDIF
IF Valtype(aOptions[7]) == 'N' ; ::largeChange := aOptions[7] ; ENDIF
IF Valtype(aOptions[8]) == 'N' ; ::selLength := aOptions[8] ; ENDIF
IF Valtype(aOptions[9]) == 'N' ; ::selStart := aOptions[9] ; ENDIF
IF Valtype(aOptions[10]) == 'N' ; ::tickFrequency := aOptions[10] ; ENDIF
IF Valtype(aOptions[12]) == 'N' ; ::value := aOptions[12] ; ENDIF

::anchorBlock := aGetListItem[bGETLIST_VAR]
::value := Eval(::anchorBlock)

::actionBlock := aGetListItem[bGETLIST_ACTION]

::subscribeEvent('change', {|x|Eval(::anchorBlock,::value),::Action()})

RETURN self

ENDCLASS

* ========================

CLASS CJ_TaskDialog FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oXOptions )
::clsid := 'CodeJock.TaskDialog' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, @oXOptions )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,42)

DEFAULT aOptions[1] := .f., ;
        aOptions[3] := xtpTaskButtonOk, ;
        aOptions[8] := .f., ;
        aOptions[9] := .f., ;
        aOptions[10] := .f., ;
        aOptions[11] := .f., ;
        aOptions[12] := .f., ;
        aOptions[13] := .f., ;
        aOptions[14] := .f., ;
        aOptions[15] := .f., ;
        aOptions[16] := .f., ;
        aOptions[17] := .f., ;
        aOptions[18] := .f., ;
        aOptions[21] := xtpTaskIconNone, ;
        aOptions[25] := xtpTaskIconNone, ;
        aOptions[29] := xtpTaskProgressBarNone, ;
        aOptions[30] := .f.

::allowCancellation := aOptions[1]
IF Valtype(aOptions[2]) == 'C' ; ::collapsedControlText := aOptions[2] ; ENDIF
::commonButtons := aOptions[3]
IF Valtype(aOptions[4]) == 'C' ; ::contentText := aOptions[4] ; ENDIF
IF Valtype(aOptions[5]) == 'N' ; ::defaultButton := aOptions[5] ; ENDIF
IF Valtype(aOptions[6]) == 'N' ; ::defaultRadioButton := aOptions[6] ; ENDIF
IF Valtype(aOptions[7]) == 'N' ; ::dialogWidth := aOptions[7] ; ENDIF
::enableCallBackTimer := aOptions[8]
::enableCommandLinks := aOptions[9]
::enableHyperlinks := aOptions[10]
::enableMarkup := aOptions[11]
::expandedByDefault := aOptions[12]
::expandFooterArea := aOptions[13]
::messageBoxStyle := aOptions[14]
::rtlLayout := aOptions[15]
::showCommandLinkIcons := aOptions[16]
::useComCtl32 := aOptions[17]
::verifyCheckState := aOptions[18]
IF Valtype(aOptions[19]) == 'C' ; ::expandedControlText := aOptions[19] ; ENDIF
IF Valtype(aOptions[20]) == 'C' ; ::expandedInformationText := aOptions[20] ; ENDIF
::footerIcon := aOptions[21]
IF Valtype(aOptions[22]) == 'N' ; ::footerIconHandle := aOptions[22] ; ENDIF
IF Valtype(aOptions[23]) == 'C' ; ::footerText := aOptions[23] ; ENDIF
IF Valtype(aOptions[24]) == 'C' ; ::inputBoxText := aOptions[24] ; ENDIF
::mainIcon := aOptions[25]
IF Valtype(aOptions[26]) == 'N' ; ::mainIconHandle := aOptions[26] ; ENDIF
IF Valtype(aOptions[27]) == 'C' ; ::mainInstructionText := aOptions[27] ; ENDIF
IF Valtype(aOptions[28]) == 'N' ; ::progressBarPos := aOptions[28] ; ENDIF
::progressBarStyle := aOptions[29]
::relativePosition := aOptions[30]
IF Valtype(aOptions[31]) == 'C' ; ::verificationText := aOptions[31] ; ENDIF
IF Valtype(aOptions[32]) == 'C' ; ::windowTitle := aOptions[32] ; ENDIF
::AddRadioButtons(aOptions[33],aOptions[34])
::AddButtons(aOptions[35],aOptions[36])
IF Valtype(aOptions[37]) == 'B' ; ::hyperlinkClicked := aOptions[37] ; ENDIF
IF Valtype(aOptions[38]) == 'B' ; ::radioButtonClicked := aOptions[38] ; ENDIF
IF Valtype(aOptions[39]) == 'B' ; ::buttonClicked := aOptions[39] ; ENDIF
IF Valtype(aOptions[40]) == 'B' ; ::verificationClicked := aOptions[40] ; ENDIF
IF Valtype(aOptions[41]) == 'B' ; ::constructed := aOptions[41] ; ENDIF
IF Valtype(aOptions[42]) == 'B' ; ::timer := aOptions[42] ; ENDIF

RETURN self

* ----------

INLINE METHOD AddRadioButtons( aButtons, nStartID )

LOCAL i
DEFAULT nStartId := 200

FOR i := 1 TO Len(aButtons)
  ::AddRadioButton(aButtons[i],nStartId-1+i)
NEXT

RETURN nil

* ------------

INLINE METHOD AddButtons( aButtons, nStartId )

LOCAL i
DEFAULT nStartId := 100

FOR i := 1 TO Len(aButtons)
  ::AddButton(aButtons[i],nStartId-1+i)
NEXT

RETURN nil

ENDCLASS

* ========================

CLASS CJ_PopupControl FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.PopupControl' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )
LOCAL aGetListItem, aOptions

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,16)

DEFAULT aOptions[1] := .f., ;
        aOptions[3] := xtpPopupAnimationNone, ;
        aOptions[6] := xtpPopupLocationNearTaskBar, ;
        aOptions[7] := .f.
        aOptions[10] := .f.
        aOptions[13] := xtpPopupThemeOffice2000

::allowMove := aOptions[1]
IF Valtype(aOptions[2]) == 'N' ; ::animateDelay := aOptions[2] ; ENDIF
::animation := aOptions[3]
IF !Empty(aOptions[4]) ; ::backgroundBitmap := aOptions[4] ; ENDIF
IF Valtype(aOptions[5]) == 'N' ; ::bottom := aOptions[5] ; ENDIF
::enableMarkup := aOptions[7]
IF Valtype(aOptions[8]) == 'N' ; ::height := aOptions[8] ; ENDIF
IF Valtype(aOptions[9]) == 'N' ; ::right := aOptions[9] ; ENDIF
::rightToLeft := aOptions[10]
IF Valtype(aOptions[11]) == 'N' ; ::showDelay := aOptions[11] ; ENDIF
IF Valtype(aOptions[12]) == 'N' ; ::transparency := aOptions[12] ; ENDIF
::visualTheme := aOptions[13]
IF Valtype(aOptions[14]) == 'N' ; ::width := aOptions[14] ; ENDIF
IF Valtype(aOptions[15]) == 'B' ; ::itemClick := {||PostAppEvent(DCGUI_EVENT_ACTION,aOptions[15],,self)} ; ENDIF
IF Valtype(aOptions[16]) == 'B' ; ::stateChanged := aOptions[16] ; ENDIF

RETURN self

ENDCLASS

* ========================

CLASS CJ_ScrollBar FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oXOptions )
::clsid := 'CodeJock.ScrollBar' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, @oXOptions )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL aGetListItem, aOptions

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,12)

DEFAULT aOptions[1] := xtpAppearanceUltraFlat, ;
        aOptions[2] := .f., ;
        aOptions[6] := xtpScrollBarHorizontal, ;
        aOptions[8] := .f.

::appearance := aOptions[1]
::autoSize := aOptions[2]
IF Valtype(aOptions[3]) == 'N' ; ::largeChange := aOptions[3] ; ENDIF
IF Valtype(aOptions[4]) == 'N' ; ::min := aOptions[4] ; ENDIF
IF Valtype(aOptions[5]) == 'N' ; ::max := aOptions[5] ; ENDIF
IF Valtype(aOptions[7]) == 'N' ; ::smallChange := aOptions[7] ; ENDIF
::useVisualStyle := aOptions[8]
IF Valtype(aOptions[9]) == 'N' ; ::value := aOptions[9] ; ENDIF

::anchorBlock := aGetListItem[bGETLIST_VAR]
::value := Eval(::anchorBlock)

::actionBlock := aGetListItem[bGETLIST_ACTION]

::subscribeEvent('change', {|x|Eval(::anchorBlock,::value),::Action()})

RETURN self

ENDCLASS

* ========================

CLASS CJ_TabControl FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

VAR numPages
VAR lastTab

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.TabControl' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
::numPages := 0
RETURN self

* ------------

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )
LOCAL aOptions, aGetListItem
::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )
aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]
ASize(aOptions,15)

DEFAULT aOptions[1] := .f., ;
        aOptions[2] := .f., ;
        aOptions[3] := .f., ;
        aOptions[4] := .f., ;
        aOptions[5] := 0, ;
        aOptions[7] := 0, ;
        aOptions[10] := 0, ;
        aOptions[12] := xtpTabColorWinXP, ;
        aOptions[13] := xtpTabLayoutFixed, ;
        aOptions[14] := xtpTabPositionTop, ;
        aOptions[15] := 100

::allowReorder := aOptions[1]
::autoResizeClient := aOptions[2]
::drawFocusRect := aOptions[3]
::enableMarkup := aOptions[4]
::appearance := aOptions[5]
IF !Empty(aOptions[6])
  ::setProperty('font',CJ_Font(aOptions[6]))
ENDIF
::headerScrollOffset := aOptions[7]
IF !Empty(aOptions[8])
  ::setProperty('icons',aOptions[8])
ENDIF
IF !Empty(aOptions[9])
  ::itemCount := aOptions[9]
ENDIF
::selectedItem := aOptions[10]

IF !Empty(aOptions[11])
  ::toolTipContext := aOptions[11]
ENDIF
::color := aOptions[12]
::paintManager:layout := aOptions[13]
::paintManager:position := aOptions[14]
::PaintManager:MultiRowJustified      := .T.
::PaintManager:MultiRowFixedSelection := .T.
::PaintManager:RotateImageOnVerticalDraw := .T.
::PaintManager:BoldSelected          := .T.
::PaintManager:HotTracking           := .T.
::PaintManager:StaticFrame           := .F.
::PaintManager:DrawTextNoPrefix      := .F.
::PaintManager:FillBackground        := .T.
::PaintManager:ShowIcons             := .T.
::PaintManager:FixedTabWidth         := aOptions[15]

::resize := {|a,b,o|::TabResize(a,b,o)}
::selectedChanged := {|oItem|::selectedChanged(oItem)}
::lastTab := 0
::loadedIcons := {}

RETURN self

* ------------

INLINE METHOD TabResize( aOldSize, aNewSize, oTabControl )

LOCAL i, oXbp, aChildList := ::childList()

FOR i := 1 TO Len(aChildList)
  oXbp := aChildList[i]
  IF oXbp:isDerivedFrom('XbpStatic')
    oXbp:setPos({0,0})
    oXbp:setSize(oTabControl:currentSize())
  ENDIF
NEXT

IF aOldSize[2] # aNewSize[2]
  ::stabilize()
ENDIF

RETURN self

* ----------

INLINE METHOD SelectedChanged( oItem )

LOCAL oTabControl := oItem:tag, aChildList, oTabControlPage

aChildList := ::childList()
IF ::lastTab # oItem:index
  oTabControlPage := aChildList[(::lastTab*2)+1]
  IF Valtype(oTabControlPage:lostFocus) == 'B'
    Eval(oTabControlPage:lostFocus,oTabControlPage)
  ENDIF
  oTabControlPage:minimized := .t.
ENDIF

oTabControlPage := aChildList[(oItem:index*2)+1]

IF Valtype(oTabControlPage:gotFocus) == 'B' .AND. ::lastTab # oItem:index
  Eval(oTabControlPage:gotFocus,oTabControlPage)
ENDIF
oTabControlPage:minimized := .f.
::lastTab := oItem:index

RETURN self

* -----------

INLINE METHOD Stabilize()

// This makes child objects reappear if they have disappeared after a vertical resize

::setParent():lockUpdate(.t.)
::setSize({::currentSize()[1]+1,::currentSize()[2]})
::setSize({::currentSize()[1]-1,::currentSize()[2]})
::setParent():lockUpdate(.f.)
::setParent():invalidateRect()

RETURN self

ENDCLASS

* ========================

CLASS CJ_TabControlPage FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

VAR body
VAR tabControl
VAR tab
VAR caption
VAR iconID
VAR fgColor
VAR bgColor
VAR index
VAR minimized

METHOD Init, Create

ENDCLASS

METHOD CJ_TabControlPage:Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

::clsid := 'CodeJock.TabControlPage' + CJ_Version()

::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
::tabControl := oParent
::iconID := 0
::fgColor := GRA_CLR_BLACK
::bgColor := GRA_CLR_WHITE
::minimized := .t.
RETURN self

* -----------

METHOD CJ_TabControlPage:Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

LOCAL nHeight, nWidth, nLeft, nTop, aOptions, aGetListItem, aColor, ;
      bBlock, ncIcon

::DC_XbpActiveXControl:create( @oParent, @oOwner, {0,0}, {1,1}, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
::tabControl:numPages++

::caption := aGetListItem[cGETLIST_CAPTION]
::gotFocus := DC_GetBlock(aGetListItem[bGETLIST_GOTFOCUS])
::lostFocus := DC_GetBlock(aGetListItem[bGETLIST_LOSTFOCUS])

IF Empty(::caption)
  ::caption := 'Tab ' + Alltrim(Str(::tabControl:numPages))
ENDIF

aColor := DC_GetBlock(aGetListItem[aGETLIST_COLOR])
IF Valtype(aColor)#'B'
  aColor := aGetListItem[aGETLIST_COLOR]
ENDIF
IF !Empty(aColor)
  ::fgColor := aColor[1]
  ::bgColor := aColor[2]
  IF Valtype(::fgColor) == 'A'
    ::fgColor := GraMakeRGBColor(::fgColor)
  ENDIF
  IF Valtype(::bgColor) == 'A'
    ::bgColor := GraMakeRGBColor(::bgColor)
  ENDIF
ENDIF

aOptions := aGetListItem[xGETLIST_OPTIONS3]
ASize(aOptions,3)

DEFAULT aOptions[1] := .f.
IF !Empty(aOptions[2])
  ::picture := aOptions[2]
ENDIF
IF !Empty(aOptions[3])
  ncIcon := aOptions[3]
ENDIF

::Body := XbpStatic():new(::tabControl, ,{0,0}, ::tabControl:currentSize(), ;
   {{ XBP_PP_FGCLR, ::fgColor}, ;
    { XBP_PP_BGCLR, ::bgColor}} )

::Body:clipSiblings := .t.
::Body:create():Show()

::index := ::tabControl:numPages
::iconID := ::TabControl:LoadIcon(ncIcon,::index)
::tab := ::TabControl:insertItem( ::index, ;
                                  ::caption, ;
                                  ::hWnd, ;
                                  ::iconID )
::tab:enabled := .T.
::tab:EnsureVisible()
::tab:tag := ::tabControl

CJ_SetXParent(::Body:getHWND(),::hWnd)

bBlock := DC_GetBlock(aGetListItem[xGETLIST_OPTIONS4],'O')
IF Valtype(bBlock) = 'B'
  Eval( bBlock, ::body )
ENDIF

::AutoSize := aOptions[1]
RETURN self

* ========================

CLASS CJ_CommandBars FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:
VAR createStaticArea
VAR staticArea
VAR control
VAR left
VAR right
VAR top
VAR bottom

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.CommandBars' + CJ_Version()
::license := CJ_LicenseCommandBars()

::DC_XbpActiveXControl:init( oParent, oOwner, {0,0}, {1,1}, aPres, lVisible, oGetList )

AAdd(oGetList:userEvents, { xbeP_User+12345, {|mp1|Eval(mp1)}} )
::CJ_Parts:init()

::left := ::top := ::right := ::bottom := 0

RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )
LOCAL aGetListItem, aOptions, oOptions

::DC_XbpActiveXControl:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,7)

DEFAULT aOptions[1] := .f., ;
        aOptions[2] := xtpScalePixel, ;
        aOptions[3] := xtpThemeOfficeXP, ;
        aOptions[5] := .f., ;
        aOptions[6] := .f., ;
        aOptions[7] := .f.

::rightToLeft := aOptions[1]
::scaleMode := aOptions[2]
::visualTheme := aOptions[3]
IF Valtype(aOptions[4]) == 'B'
  ::execute := {|o|::control:=o,PostAppEvent(DCGUI_EVENT_ACTION,aOptions[4],o,self)}
ELSE
  ::execute := {|o|::control:=o,PostAppEvent(DCGUI_EVENT_ACTION,{|o|::executeAction(o)},o,self)}
ENDIF

oOptions := ::getProperty('options')
oOptions:showExpandButtonAlways := aOptions[6]
oOptions:showTextBelowIcons := aOptions[7]
::createStaticArea := aOptions[5]

RETURN self

INLINE METHOD AddAction( aAction )

LOCAL bAction

IF Valtype(aAction)=='A' .AND. Valtype(aAction[1])=='N' .AND. Valtype(aAction[2]) == 'B'
  AAdd( ::actionArray, aAction )
ENDIF

RETURN self

INLINE METHOD ExecuteAction( oControl )

LOCAL nId, nFound, bAction

IF oControl == NIL
  oControl := ::control
ENDIF

nId := oControl:id

nFound := AScan(::actionArray,{|a|a[1]==nId})
IF nFound > 0
  bAction := ::actionArray[nFound,2]
  IF Valtype(bAction) == 'B'
    Eval(bAction,nId,oControl,self)
  ENDIF
ENDIF

RETURN self

INLINE METHOD ResizeDrawingArea( oDlg, lResizeChildren, aGetList )

LOCAL oDrawingArea, aPos, aSize, nLeft, nTop, nRight, nBottom, ;
      aChildList, oGetList, aOldSize, aNewSize, oXbp, i

nLeft := ::left
nTop := ::top
nRight := ::right
nBottom := ::bottom
::getClientRect(@::left,@::top,@::right,@::bottom)
IF ::left==nLeft .AND. ::right==nRight .AND. ::top==nTop .AND. ::bottom==nBottom
  RETURN nil
ENDIF

IF ::createStaticArea .AND. Valtype(::staticArea) # 'O'
   ::staticArea := CJ_CreateStaticArea( oDlg:drawingArea, aGetList )
ENDIF

DEFAULT lResizeChildren := .f.

oGetList := DC_GetListObject(aGetList)
oDrawingArea := oDlg:drawingArea
aChildList := oDrawingArea:childList()

aPos := {::left,oDrawingArea:CurrentSize()[2]-::bottom}
aSize := {::right-::left,::bottom-::top}

IF lResizeChildren
  FOR i := 1 TO Len(aChildList)
    oXbp := aChildList[i]
    IF oXbp:isDerivedFrom("CJ_CommandBars")
      LOOP
    ENDIF
    IF aPos[1] # oXbp:currentPos()[1] .OR. ;
       aPos[2] # oXbp:currentPos()[2] .OR. ;
       aSize[1] # oXbp:currentSize()[1] .OR. ;
       aSize[2] # oXbp:currentSize()[2]

      aOldSize := oXbp:currentSize()

      oXbp:setPosAndSize(aPos,aSize)
      aNewSize := oXbp:currentSize()

      DC_ReSize(aOldSize,aNewSize,oXbp,aGetList,oGetList)
      oXbp:invalidateRect()
    ENDIF
  NEXT
ENDIF

RETURN self

ENDCLASS

* ========================

CLASS CJ_DockingPane FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:
VAR control
VAR left
VAR right
VAR top
VAR bottom

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.DockingPane' + CJ_Version()
::license := CJ_LicenseDockingPane()

::DC_XbpActiveXControl:init( oParent, oOwner, {0,0}, {1,1}, aPres, lVisible, oGetList )

::CJ_Parts:init()

::left := ::top := ::right := ::bottom := 0

RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )
LOCAL aGetListItem, aOptions, oOptions

::DC_XbpActiveXControl:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,2)

DEFAULT aOptions[1] := xtpScalePixel, ;
        aOptions[2] := xtpThemeOfficeXP

::scaleMode := aOptions[1]
::visualTheme := aOptions[2]

RETURN self

INLINE METHOD ResizeDrawingArea( oDlg, lResizeChildren, aGetList )

LOCAL oDrawingArea, aPos, aSize, nLeft, nTop, nRight, nBottom, ;
      aChildList, oGetList, aOldSize, aNewSize, oXbp, i

nLeft := ::left
nTop := ::top
nRight := ::right
nBottom := ::bottom
::getClientRect(@::left,@::top,@::right,@::bottom)
IF ::left==nLeft .AND. ::right==nRight .AND. ::top==nTop .AND. ::bottom==nBottom
  RETURN nil
ENDIF

IF ::createStaticArea .AND. Valtype(::staticArea) # 'O'
   ::staticArea := CJ_CreateStaticArea( oDlg:drawingArea, aGetList )
ENDIF

DEFAULT lResizeChildren := .f.

oGetList := DC_GetListObject(aGetList)
oDrawingArea := oDlg:drawingArea
aChildList := oDrawingArea:childList()

aPos := {::left,oDrawingArea:CurrentSize()[2]-::bottom}
aSize := {::right-::left,::bottom-::top}

IF lResizeChildren
  FOR i := 1 TO Len(aChildList)
    oXbp := aChildList[i]
    IF oXbp:isDerivedFrom("CJ_CommandBars")
      LOOP
    ENDIF
    IF aPos[1] # oXbp:currentPos()[1] .OR. ;
       aPos[2] # oXbp:currentPos()[2] .OR. ;
       aSize[1] # oXbp:currentSize()[1] .OR. ;
       aSize[2] # oXbp:currentSize()[2]

      aOldSize := oXbp:currentSize()

      oXbp:setPosAndSize(aPos,aSize)
      aNewSize := oXbp:currentSize()

      DC_ReSize(aOldSize,aNewSize,oXbp,aGetList,oGetList)
      oXbp:invalidateRect()
    ENDIF
  NEXT
ENDIF

RETURN self

ENDCLASS


* =====================

CLASS CJ_ShortcutBar FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

VAR windows

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.ShortcutBar' + CJ_Version()
::license := CJ_LicenseShortcutBar()

::DC_XbpActiveXControl:init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

::CJ_Parts:init()

RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )
LOCAL aGetListItem, aOptions, oOptions

::DC_XbpActiveXControl:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

DEFAULT aOptions := {}
ASize(aOptions,8)

DEFAULT aOptions[1] := xtpShortcutThemeOffice2007 , ;
        aOptions[2] := 5, ;
        aOptions[3] := .t., ;
        aOptions[4] := {||::shortcutBarResize()}, ;
        aOptions[5] := {|a,b,c|::shortcutBarResize(a,b,c)}, ;
        aOptions[6] := {||::actionEval()}, ;
        aOptions[7] := .t.

::VisualTheme := aOptions[1]
::expandedLinesCount := aOptions[2]
::clientPaneVisible := aOptions[3]
::expandButtonDown := aOptions[4]
::clientSizeChanged := aOptions[5]
::selectedchanged := aOptions[6]
::singleSelection := aOptions[7]
::windows := aOptions[8]

RETURN self

INLINE METHOD ShortCutBarResize()

LOCAL i, oItem, nId, aOldSize, aNewSize, aGetList := ::getList:getListArray

oItem := ::selected()
IF oItem == NIL
  RETURN nil
ENDIF

nId := oItem:id

i := AScan(::windows,{|a|a[3]==nId})
IF Valtype(::windows[i,1]) == 'O'
  aOldSize := ::windows[i,4]
  ::windows[i,1]:setSize({::clientwidth,::clientHeight})
  aNewSize := ::windows[i,1]:currentSize()
  ::reposChildren(i,aOldSize,aNewSize)
  ::windows[i,1]:invalidateRect()
  ::windows[i,4] := aNewSize
ENDIF

RETURN nil

INLINE METHOD reposChildren( nWindow, aOldSize, aNewSize )

LOCAL i, oXbp := ::windows[nWindow,1], aChildren := oXbp:childList()
LOCAL nYDelta := aNewSize[2] - aOldSize[2]

IF nYDelta # 0
  FOR i := 1 TO Len(aChildren)
    oXbp := aChildren[i]
    oXbp:setPos({ oXbp:currentPos()[1],oXbp:currentPos()[2]+nYDelta})
  NEXT
ENDIF

RETURN self

INLINE METHOD ActionEval()

Local i, oItem := ::selected(), aGetList := ::getList:getListArray

::resize()

FOR i := 1 TO Len(::windows)
  IF Valtype(::windows[i,1]) == 'O'
    IF ::windows[i,3] == oItem:id
      ::windows[i,1]:show()
    ELSE
      ::windows[i,1]:hide()
    ENDIF
  ENDIF
NEXT

RETURN nil

ENDCLASS

* ========================

CLASS CJ_ReportControl FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.ReportControl' + CJ_Version()
::license := CJ_LicenseReportControl()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )

RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )
RETURN self

ENDCLASS

* ========================

CLASS CJ_PushButton FROM DC_XbpActiveXControl, CJ_Parts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )
::clsid := 'CodeJock.PushButton' + CJ_Version()
::license := CJ_LicenseControls()
::DC_XbpActiveXControl:init( @oParent, @oOwner, aPos, aSize, aPres, lVisible, oGetList )
RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )
LOCAL aGetListItem, aOptions, cFont, cCaption, aColor

::DC_XbpActiveXControl:create( @oParent, @oOwner, aPos, aSize, aPres, lVisible )

aGetListItem := ::getList:getListArray[::getListPointer]
aOptions := aGetListItem[xGETLIST_OPTIONS3]

cFont := aGetListItem[cGETLIST_FONT]
IF !Empty(cFont)
//  ::setFont(CJ_Font(cFont,.f.))
//  ::setProperty('font',CJ_Font(cFont)) // << locks up app
ENDIF


DEFAULT aOptions := {}
ASize(aOptions,23)

DEFAULT aOptions[1] := xtpAppearanceFlat, ;
        aOptions[2] := 2, ;
        aOptions[4] := .f., ;
        aOptions[5] := .f., ;
        aOptions[6] := .t., ;
        aOptions[7] := .f., ;
        aOptions[8] := .f., ;
        aOptions[11] := 2, ;
        aOptions[12] := xtpAlignLeft, ;
        aOptions[14] := .t., ;
        aOptions[15] := .f., ;
        aOptions[16] := xtpButtonNormal, ;
        aOptions[17] := xtpAlignCenter, ;
        aOptions[18] := xtpImageBeforeText, ;
        aOptions[19] := .f., ;
        aOptions[20] := .f.

// ::borderGap := aOptions[2]
IF Valtype(aOptions[3]) == 'O'
  ::buddyControl := aOptions[3]
ENDIF
::checked := aOptions[4]
::default := aOptions[5]
::drawFocusRect := aOptions[6]
::flatStyle := aOptions[7]
::enableMarkup := aOptions[8]
::imageGap := aOptions[11]
::imageAlignment := aOptions[12]
::rightToLeft := aOptions[15]
::style := aOptions[16]
::textAlignment := aOptions[17]
::textImageRelation := aOptions[18]
::transparent := aOptions[19]
::useVisualStyle := aOptions[20]
::setProperty("multiLine",aOptions[14])

IF Valtype(aOptions[21]) == 'B'
  ::click := {||PostAppEvent(DCGUI_EVENT_ACTION,aOptions[21],,self)}
ENDIF
IF Valtype(aOptions[22]) == 'B'
  ::dropDown := {||PostAppEvent(DCGUI_EVENT_ACTION,aOptions[22],,self)}
ENDIF
IF Valtype(aOptions[23]) == 'B'
  ::keyDown := {||PostAppEvent(DCGUI_EVENT_ACTION,aOptions[23],,self)}
ENDIF

cCaption := aGetListItem[cGETLIST_CAPTION]
::caption := cCaption

::setColor( aGetListItem )

IF !Empty(aOptions[10])
  ::picture := CJ_Picture(aOptions[10],xtpImageNormal)
ENDIF

::appearance := aOptions[1]


RETURN self

ENDCLASS


