#INCLUDE "common.CH"
#INCLUDE "XCodeJock.CH"
#INCLUDE "dcdialog.CH"
#INCLUDE "appevent.CH"
#INCLUDE "calendar.CH"
#INCLUDE "dll.CH"

#define CRLF Chr(13)+Chr(10)

#pragma Library("ASCOM10.LIB")

GETSETFUNCTION CJ_Express DEFAULT .f.

DLLFUNCTION GetModuleHandleA( cModule ) USING STDCALL FROM KERNEL32.DLL

* ------------

FUNCTION CJ_LicenseSkinFramework( cLicense )

STATIC scLicense := ''
LOCAL cOldLicense

cOldLicense := scLicense

IF Valtype(cLicense) == 'C'
  scLicense := cLicense
ENDIF

RETURN cOldLicense

* ------------

FUNCTION CJ_LicenseReportControl( cLicense )

STATIC scLicense := ''
LOCAL cOldLicense

cOldLicense := scLicense

IF Valtype(cLicense) == 'C'
  scLicense := cLicense
ENDIF

RETURN cOldLicense

* ------------

FUNCTION CJ_LicenseCalendar( cLicense )

STATIC scLicense := ''
LOCAL cOldLicense

cOldLicense := scLicense

IF Valtype(cLicense) == 'C'
  scLicense := cLicense
ENDIF

RETURN cOldLicense

* ------------

FUNCTION CJ_LicenseControls( cLicense )

STATIC scLicense := ''
LOCAL cOldLicense

cOldLicense := scLicense

IF Valtype(cLicense) == 'C'
  scLicense := cLicense
ENDIF

RETURN cOldLicense

* ------------

FUNCTION CJ_LicenseDockingPane( cLicense )

STATIC scLicense := ''
LOCAL cOldLicense

cOldLicense := scLicense

IF Valtype(cLicense) == 'C'
  scLicense := cLicense
ENDIF

RETURN cOldLicense

* ------------

FUNCTION CJ_LicenseCommandBars( cLicense )

STATIC scLicense := ''
LOCAL cOldLicense

cOldLicense := scLicense

IF Valtype(cLicense) == 'C'
  scLicense := cLicense
ENDIF

RETURN cOldLicense

* ------------

FUNCTION CJ_LicenseShortCutBar( cLicense )

STATIC scLicense := ''
LOCAL cOldLicense

cOldLicense := scLicense

IF Valtype(cLicense) == 'C'
  scLicense := cLicense
ENDIF

RETURN cOldLicense

* ------------

FUNCTION CJ_LicenseSyntaxEdit( cLicense )

STATIC scLicense := ''
LOCAL cOldLicense

cOldLicense := scLicense

IF Valtype(cLicense) == 'C'
  scLicense := cLicense
ENDIF

RETURN cOldLicense

* ------------

FUNCTION CJ_LicensePropertyGrid( cLicense )

STATIC scLicense := ''
LOCAL cOldLicense

cOldLicense := scLicense

IF Valtype(cLicense) == 'C'
  scLicense := cLicense
ENDIF

RETURN cOldLicense

* ------------

FUNCTION CJ_LicenseTaskPanel( cLicense )

STATIC scLicense := ''
LOCAL cOldLicense

cOldLicense := scLicense

IF Valtype(cLicense) == 'C'
  scLicense := cLicense
ENDIF

RETURN cOldLicense

* ------------

FUNCTION CJ_Version( cVersion )

STATIC scVersion
LOCAL cOldVersion

IF Empty(scVersion)
  scVersion := GetEnv('CODEJOCK_VERSION')
  IF Empty(scVersion)
    scVersion := GetEnv('CODEJOCKVERSION')
  ENDIF
ENDIF

cOldVersion := scVersion

IF Valtype(cVersion) == 'C'
  scVersion := cVersion
ENDIF

RETURN '.' + cOldVersion

* --------------

FUNCTION CJ_XCodeJockVersion( n )

n := IIF( Valtype(n)='N',n,0 )
IF n = 0
  RETURN 'XCodeJock (c) Version 1.9 (beta)'
ELSEIF n = 1
  RETURN '1'
ELSEIF n = 2
  RETURN '9'
ELSEIF n = 3
  RETURN '001.19'
ENDIF
RETURN ''

* --------------

GETSETFUNCTION CJ_RowPixels DEFAULT 20
GETSETFUNCTION CJ_ColPixels DEFAULT 7

* --------------

FUNCTION CJ_Font( cFont, lIFont )

LOCAL cCompoundName, cFamilyName, nPointSize, oFont, oPS, oIFont

DEFAULT lIFont := .t.

cCompoundName := Alltrim(cFont)
IF 'UNDERSCORE' $ Upper(cCompoundName)
  cCompoundName := StrTran(cCompoundName,' UNDERSCORE','')
  cCompoundName := StrTran(cCompoundName,' Underscore','')
  cCompoundName := StrTran(cCompoundName,' UnderScore','')
  cCompoundName := StrTran(cCompoundName,' underscore','')
ENDIF
IF 'BOLD' $ Upper(cCompoundName)
  cCompoundName := StrTran(cCompoundName,' BOLD','')
  cCompoundName := StrTran(cCompoundName,' Bold','')
  cCompoundName := StrTran(cCompoundName,' bold','')
ENDIF
IF 'ITALIC' $ Upper(cCompoundName)
  cCompoundName := StrTran(cCompoundName,' ITALIC','')
  cCompoundName := StrTran(cCompoundName,' Italic','')
  cCompoundName := StrTran(cCompoundName,' italic','')
ENDIF
IF 'SERIF' $ Upper(cCompoundName)
  cCompoundName := StrTran(cCompoundName,'MS Sans Serif','Arial')
  cCompoundName := StrTran(cCompoundName,'MS Serif','Arial')
ENDIF

cFamilyName := Alltrim(StrTran(CJ_Token(cCompoundName,'.',2),'.',' '))
cFamilyName := StrTran(cFamilyName,'  ',' ')

nPointSize := Val(CJ_Token(cCompoundName,'.',1))

oFont := XbpFont():new( oPS ):create(cCompoundName)

oFont:nominalPointSize := Int(nPointSize)
oFont:generic := .t.

IF Upper(cFamilyName) == 'TERMINAL' .AND. !Empty(oPS)
  oFont := XbpFont():new( oPS )
  oFont:nominalPointSize := nPointSize
  oFont:generic := .t.
  oFont:fixed := .t.
  oFont:familyName := cFamilyName
  oFont:create(cCompoundName)
ELSE
  oFont:configure(cCompoundName)
ENDIF

IF '.UNDERSCORE' $ Upper(cFont) .OR. ' UNDERSCORE' $ Upper(cFont)
  oFont:UnderScore := .t.
ENDIF

IF '.BOLD' $ Upper(cFont) .OR. ' BOLD' $ Upper(cFont)
  oFont:bold := .t.
ENDIF

IF '.ITALIC' $ Upper(cFont) .OR. ' ITALIC' $ Upper(cFont)
  oFont:italic := .t.
ENDIF

oFont:configure()

IF lIFont
  oFont := oFont:getIFont()
ENDIF

RETURN oFont

* -------------

FUNCTION CJ_Color( anColor, lFromActiveX )

LOCAL nColor

DEFAULT lFromActiveX := .f.

IF Valtype(anColor) == 'A'
  anColor := GraMakeRGBColor( anColor )
ENDIF

nColor := AutomationTranslateColor(anColor,lFromActiveX)

RETURN nColor

* -------------

FUNCTION CJ_Token ( cString, cDelims, nOccur )

LOCAL aTokens := CJ_TokenArray( cString, cDelims )

IF Empty(aTokens) .OR. nOccur > LEN(aTokens)
  RETURN ''
ENDIF
RETURN aTokens[nOccur]

* -------------

FUNCTION CJ_Picture( xImage, nImageState )

LOCAL oBitmap, oPicture

IF Valtype(xImage) $ 'CN'
  oBitmap := DC_GetBitmap(xImage)
ELSEIF Valtype(xImage) == 'O' .AND. xImage:isDerivedFrom('XbpBitmap')
  oBitmap := xImage
ELSEIF Valtype(xImage) == 'O' .AND. xImage:isDerivedFrom('AutomationObject')
  IF xImage:interfaceName == 'ImageManagerIcon'
    oPicture := xImage:CreatePicture(nImageState)
  ELSEIF xImage:interfaceName == 'Picture'
    oPicture := xImage
  ENDIF
ENDIF
IF Valtype(oBitmap) == 'O'
  oPicture := oBitmap:getIPicture()
ENDIF

RETURN oPicture

* -------------

FUNCTION CJ_TokenArray( cString, cDelims, lQuote )

LOCAL nFound, i, lStart, lQuoteOn, cInString, cChar, nCount := 0, ;
      aTokens[0]

DEFAULT lQuote TO .f.

cDelims := IIF(Valtype(cDelims)='C',cDelims,_TokenDelims() )
IF EMPTY(cString)
  RETURN aTokens
ENDIF
IF lQuote
  lQuoteOn := .F.
  cInString := cString
  cString := ''
  FOR i := 1 TO Len(cInString)
    cChar := cInString[i]
    IF cChar == '"'
      lQuoteOn := !lQuoteOn
    ELSEIF !lQuoteOn .AND. cChar $ cDelims
      cChar := Chr(0)
    ENDIF
    cString += cChar
  NEXT
  cString := StrTran(cString,'"','')
ELSE
  FOR i := 1 TO LEN(cDelims)
    cString := Strtran(cString,SubStr(cDelims,i,1),CHR(0))
  NEXT
ENDIF
IF Len(cDelims) > 1
  IF CHR(0)+CHR(0) $ cString
    cString := StrTran(cString,CHR(0)+CHR(0),CHR(0))
  ENDIF
ENDIF
DO WHILE .t.
  nFound := AT(CHR(0),cString)
  IF nFound = 1 //.AND. Len(aTokens)=0
    AADD( aTokens,'' )
    cString := Substr(cString,2)
  ELSEIF nFound > 0
    AADD( aTokens, SubStr(cString,1,nFound-1) )
    cString := SubStr(cString,nFound+1)
  ELSE
    AADD( aTokens, cString )
    EXIT
  ENDIF
ENDDO

RETURN aTokens

* ------------

STATIC FUNCTION _TokenDelims()

RETURN ' ,.;:!?/()#&%+-*'+CHR(0)+CHR(9)+CHR(10)+CHR(13)+CHR(26)

* ------------

FUNCTION CJ_ApplyMarkupParams( cMarkup, aParams, aReplace )

LOCAL i, j, aList[0], cItem

FOR i := 1 TO Len(aParams)
   cItem := cMarkup
   FOR j := 1 TO Len(aReplace)
     cItem := Strtran(cItem,aReplace[j],DC_XtoC(aParams[i,j]))
   NEXT
   AAdd( aList, cItem )
NEXT

RETURN aList

* ------------

FUNCTION CJ_VBColor( aRGB )

RETURN GraMakeRGBColor( aRGB ) - 16777216

* ------------

FUNCTION CJ_Default( p1, p2 )

DEFAULT p1 := p2

RETURN p1

* ------------

FUNCTION CJ_EventLoop()

LOCAL nEvent, mp1, mp2, oXbp

nEvent := 0

DO WHILE nEvent # xbeP_Close
  nEvent := AppEvent( @mp1, @mp2, @oXbp, 1 )
  IF nEvent > 0
    oXbp:handleEvent( nEvent, mp1, mp2 )
  ENDIF
ENDDO

RETURN nil

* -------------

FUNCTION CJ_IsOption( nValue, nOption )

RETURN (BAnd(nValue, nOption) != 0)

* -------------

FUNCTION CJ_CalendarHitCodeArray( nValue, aOutCodes )

LOCAL lHit, nCode, aCodes, cString := '', i

aOutCodes := Array(0)

aCodes := { ;
{ xtpCalendarHitTestUnknown,            'xtpCalendarHitTestUnknown' }, ;
{ xtpCalendarHitTestDayArea,            'xtpCalendarHitTestDayArea' }, ;
{ xtpCalendarHitTestDayHeader,          'xtpCalendarHitTestDayHeader' }, ;
{ xtpCalendarHitTestGroupArea,          'xtpCalendarHitTestGroupArea' }, ;
{ xtpCalendarHitTestGroupHeader,        'xtpCalendarHitTestGroupHeader' }, ;
{ xtpCalendarHitTestEventDragArea,      'xtpCalendarHitTestEventDragArea' }, ;
{ xtpCalendarHitTestEventTextArea,      'xtpCalendarHitTestEventTextArea' }, ;
{ xtpCalendarHitTestEventResizeVArea,   'xtpCalendarHitTestEventResizeVArea' }, ;
{ xtpCalendarHitTestEventResizeHArea,   'xtpCalendarHitTestEventResizeHArea' }, ;
{ xtpCalendarHitTestEventResizeBegin,   'xtpCalendarHitTestEventResizeBegin' }, ;
{ xtpCalendarHitTestEventResizeEnd,     'xtpCalendarHitTestEventResizeEnd' }, ;
{ xtpCalendarHitTestDayViewTimeScale,   'xtpCalendarHitTestDayViewTimeScale' }, ;
{ xtpCalendarHitTestDayViewCell,        'xtpCalendarHitTestDayViewCell' }, ;
{ xtpCalendarHitTestDayViewAllDayEvent, 'xtpCalendarHitTestDayViewAllDayEvent' } }

FOR i := 1 TO Len(aCodes)
  IF CJ_IsOption( nValue, aCodes[i,1] )
    AAdd( aOutCodes, aCodes[i] )
    cString += aCodes[i,2] + ', '
  ENDIF
NEXT

RETURN cString

* -------------

FUNCTION CJ_DateTime( cDateTime, dDate, cTime )

IF Valtype(dDate) == 'D' .AND. Valtype(cTime) == 'C'
  cDateTime := Dtos(dDate) + Strtran(cTime,':','')
ENDIF

dDate := StoD(Substr(cDateTime,1,8))
cTime := Substr(cDateTime,9,2) + ':' + ;
         Substr(cDateTime,11,2) + ':' + ;
         Substr(cDateTime,13,2)

RETURN nil

* ------------

FUNCTION CJ_TsToSecs( cTimeString )

LOCAL nHours := Val( Substr(cTimeString, 1,2) )
LOCAL nMinutes := Val( Substr(cTimeString, 4,2) )

RETURN (nMinutes*60) + (nHours*3600)

* ------------

FUNCTION CJ_SecsToTS( nTimeNum )

LOCAL nAllmins := Int(nTimenum / 60)
LOCAL nHours := Int(nAllmins / 60)
LOCAL nMinutes:= Int(nAllmins % 60)
LOCAL cHours, cMinutes

if (nMinutes == 0)
   cMinutes:= "00"
elseif (nMinutes < 10)
   cMinutes:= "0" + LTrim(Str(nMinutes))
else
   cMinutes:= LTrim(Str(nMinutes))
endif
if (nHours > 12)
   IF nHours = 24
      nHours := 0
   ENDIF
endif
if (nHours < 10)
   cHours:= " " + LTrim(Str(nHours))
else
   cHours:= LTrim(Str(nhours))
endif

return Strtran(cHours + ":" + cMinutes + ":00",' ','0')

* -----------

FUNCTION CJ_JazzConvert()

LOCAL GetList[0], cInputFile := Pad('<jazzfile>.prg',50), lStatus, ;
      nHandle, cLine, cOutput, lClass, lExported, cOutputFile := Pad('<jazzfile>.def',50), ;
      cClassName, GetOptions

@ 0,0 DCSAY ' Input File' GET cInputFile SAYRIGHTBOTTOM
@ 1,0 DCSAY 'Output File' GET cOutputFile SAYRIGHTBOTTOM

DCGETOPTIONS TABSTOP
DCREAD GUI FIT ADDBUTTONS TO lStatus TITLE 'Convert JazzAge PRG file' ;
   OPTIONS GetOptions ENTEREXIT

IF !lStatus
  RETURN .f.
ENDIF

nHandle := DC_TxtOpen(Alltrim(cInputFile))
IF nHandle <= 0
  RETURN .f.
ENDIF

lClass := .f.
lExported := .f.
cOutput := ''
cOutputFile := Alltrim(cOutputFile)

DO WHILE !DC_TxtEof(nHandle)

  cLine := Alltrim(DC_TxtLine(nHandle))

  DC_TxtSkip(nHandle,1)
  IF Empty(cLine)
    LOOP
  ELSEIF Left(cLine,1) = '/'
    LOOP
  ELSEIF Left(cLine,1) = '#'
    LOOP
  ELSEIF Left(cLine,6) = 'METHOD' .AND. !lClass
    EXIT
  ELSEIF Left(cLine,7) = 'EXAMPLE'
    LOOP
  ELSEIF Left(cLine,6) = 'CLASS'
    lClass := .t.
    cClassName := Substr(cLine,8)
  ELSEIF Left(cLine,8) = 'ENDCLASS'
    lClass := .f.
    lExported := .f.
    cOutput += CRLF
  ELSEIF Left(cLine,9) = 'EXPORTED:' .AND. !lExported
    lExported := .t.
    LOOP
  ELSEIF lClass .AND. !lExported
    LOOP
  ELSEIF cLine = 'VAR ExceptionCodeBlock'
    LOOP
  ELSEIF Left(cLine,11) = 'METHOD init'
    LOOP
  ELSEIF cLine = 'METHOD _NewEnum'
    LOOP
  ENDIF
  IF cLine = 'CLASS'
    cOutput += cLine + CRLF + CRLF
  ELSEIF cLine = 'ENDCLASS'
    cOutput += cLine + CRLF + CRLF
  ELSE
    cLine := Strtran(cLine,'VAR _','VAR ')
    cLine := Strtran(cLine,'METHOD _','METHOD ')
    cOutput += '  ' + cLine + CRLF
  ENDIF

ENDDO

MemoWrit( cOutputFile, cOutput )

DCMSGBOX 'Done! ' + cOutputfile + ' created.' TIMEOUT 5

RETURN .t.

* ---------------

FUNCTION CJ_ObjectDefArray( cOCX, cClassName )

LOCAL aArray[0], aDefs[0], nHandle, cLine, i, aTokens

IF !'.' $ cOCX
  cOCX += '.def'
ENDIF

nHandle := DC_TxtOpen( CJ_DefDir() + cOCX )
IF nHandle <= 0
  RETURN aArray
ENDIF

AAdd( aDefs, { cOCX, cClassName, ' '} )
AAdd( aDefs, {} ) // Properties
AAdd( aDefs, {} ) // Methods
AAdd( aDefs, {} ) // Events

* ---- Properties and Methods ----

DC_TxtFind( nHandle, 'CLASS ' + cClassName+Chr(13), .f. )
DC_TxtSkip( nHandle,1 )
DO WHILE !DC_TxtEof(nHandle)
   cLine := DC_TxtLine(nHandle)
   DC_TxtSkip(nHandle,1)
   IF cLine = 'ENDCLASS'
     EXIT
   ENDIF
   AAdd( aArray, Alltrim(cLine))
ENDDO

FOR i := 1 TO Len(aArray)
  IF Left(aArray[i],6 ) = 'METHOD'
    AAdd( aDefs[3], Substr(aArray[i],8) )
  ELSEIF Left(aArray[i],6 ) = 'ACCESS' .OR. Left(aArray[i],6) == 'ASSIGN'
    aTokens := DC_TokenArray(aArray[i],' ')
    IF AScan(aDefs[2],aTokens[5]) == 0
      AAdd( aDefs[2], aTokens[5] )
    ENDIF
  ENDIF
NEXT

* ---- Events ----
ASize(aArray,0)
DC_TxtFind( nHandle, 'CLASS _D' + cClassName+'Events'+Chr(13), .f. )
DC_TxtSkip( nHandle,1 )
DO WHILE !DC_TxtEof(nHandle)
   cLine := DC_TxtLine(nHandle)
   DC_TxtSkip(nHandle,1)
   IF cLine = 'ENDCLASS'
     EXIT
   ENDIF
   AAdd( aArray, Alltrim(cLine))
ENDDO

FOR i := 1 TO Len(aArray)
  IF Left(aArray[i],6 ) = 'METHOD'
    AAdd( aDefs[4], Substr(aArray[i],8) )
  ENDIF
NEXT

DC_TxtClose(nHandle)

RETURN aDefs

* ---------------

GETSETFUNCTION CJ_DefDir DEFAULT '\expd19\XCodeJock\ClassDef\'

* ---------------

FUNCTION CJ_DisplayProperties( oAutomationObject )

LOCAL i, cInterfaceName, oOwner, aProperties[0], aDir, aDefs, ;
      GetList[0], GetOptions, oStatic, nRow, nWidth, nHeight, ;
      bError, lStatus, oTab1, oTab2, oTab3, oTab4, oTab5, oTab6, ;
      oTab7, oTab8, cParent

IF Valtype(oAutomationObject) # 'O' .OR. !oAutomationObject:isDerivedFrom('AutomationObject')
  DC_Winalert( 'CJ_DisplayProperties() parameter is not an AutomationObject')
  RETURN .f.
ENDIF

cInterfaceName := Strtran(oAutomationObject:interfaceName,'_D','')

oOwner := oAutomationObject:owner
aDir := Directory( CJ_DefDir()+'\*.def', cInterfaceName )

FOR i := 1 TO Len(aDir)
  aDefs := CJ_ObjectDefArray( aDir[i,1], cInterfaceName )
  IF !Empty(aDefs[2])
    EXIT
  ENDIF
NEXT

IF Empty(aDefs) .OR. Empty(aDefs[2])
  DC_Winalert( 'No Class defs for ' + cInterfaceName + ' in ' + CJ_DefDir() )
  RETURN .f.
ENDIF

@ 0,0 DCSAY 'Class Name:' FONT '8.Helv Bold'
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY cInterfaceName SAYLEFTBOTTOM SAYSIZE 0

@ 1,0 DCSAY 'Owner:' FONT '8.Helv Bold'

IF oOwner == nil
  @ DCGUI_ROW, DCGUI_COL + 10 DCSAY '<Unknown>' ;
      COLOR GRA_CLR_DARKGREEN SAYSIZE 30 FONT '10.Lucida Console'
ELSEIF oOwner:isDerivedFrom('AutomationObject')
  @ DCGUI_ROW, DCGUI_COL + 10 DCSAY Strtran(oOwner:interfaceName,'_D','') ;
      HYPERLINK {||CJ_DisplayProperties(oOwner)} SAYLEFTBOTTOM ;
      COLOR GRA_CLR_DARKGREEN SAYSIZE 30 ;
      FONT '10.Lucida Console'
ELSE
  @ DCGUI_ROW, DCGUI_COL + 10 DCSAY oOwner:className() ;
      HYPERLINK {||DC_InspectObject(oOwner)} SAYLEFTBOTTOM ;
      COLOR GRA_CLR_DARKGREEN SAYSIZE 30 FONT '10.Lucida Console'
ENDIF

nHeight := Len(aDefs[2])
nHeight := Max(nHeight,Len(aDefs[3]))
nHeight := Max(nHeight,Len(aDefs[4]))

nHeight := Min(nHeight,22)

@ 2.5, 0 DCTABPAGE oTab1 CAPTION 'Properties' SIZE 120, nHeight + 3 COLOR GRA_CLR_WHITE ID 'TAB1' TABWIDTH 15 WHEN {||Len(aDefs[2])>0}
@ 0, 0 DCTABPAGE oTab2 CAPTION 'Prop(2)' RELATIVE oTab1 COLOR GRA_CLR_WHITE ID 'TAB2' WHEN {||Len(aDefs[2])>22}
@ 0, 0 DCTABPAGE oTab3 CAPTION 'Prop(3)' RELATIVE oTab2 COLOR GRA_CLR_WHITE ID 'TAB3' WHEN {||Len(aDefs[2])>44}
@ 0, 0 DCTABPAGE oTab4 CAPTION 'Prop(4)' RELATIVE oTab3 COLOR GRA_CLR_WHITE ID 'TAB4' WHEN {||Len(aDefs[2])>66}
@ 0, 0 DCTABPAGE oTab5 CAPTION 'Methods' RELATIVE oTab4 COLOR GRA_CLR_WHITE ID 'TAB5' WHEN {||Len(aDefs[3])>0}
@ 0, 0 DCTABPAGE oTab6 CAPTION 'Methods(2)' RELATIVE oTab5 COLOR GRA_CLR_WHITE ID 'TAB6' WHEN {||Len(aDefs[3])>22}
@ 0, 0 DCTABPAGE oTab7 CAPTION 'Events' RELATIVE oTab6 COLOR GRA_CLR_WHITE ID 'TAB7' WHEN {||Len(aDefs[4])>0}
@ 0, 0 DCTABPAGE oTab8 CAPTION 'Events(2)' RELATIVE oTab7 COLOR GRA_CLR_WHITE ID 'TAB8' WHEN {||Len(aDefs[4])>22}

nRow := 2
nWidth := 80
bError := ErrorBlock({|e|Break(e)})

* --- Properties ---
cParent := 'TAB1'
FOR i := 1 TO Len(aDefs[2])
  nWidth := Max(nWidth,DC_GraQueryTextBox(aDefs[2,i],'8.Helv')[1])
  @ nRow++,2 DCSAY aDefs[2,i] + ':' FONT '8.Helv Bold' PARENTID cParent
  lStatus := .f.
  BEGIN SEQUENCE
  IF Valtype(oAutomationObject:getProperty(aDefs[2,i])) == 'O'
    @ DCGUI_ROW, DCGUI_COL + 10 ;
      DCSAY oAutomationObject:getProperty(aDefs[2,i]):interfaceName ;
      PARENTID cParent ;
      COLOR GRA_CLR_BLUE, GRA_CLR_WHITE SAYLEFTBOTTOM FONT '10.Lucida Console' ;
      HYPERLINK _HyperlinkBlock(oAutomationObject:getProperty(aDefs[2,i])) SAYSIZE 30
  ELSE
    @ DCGUI_ROW, DCGUI_COL + 10 ;
      DCSAY DC_XtoC(oAutomationObject:getProperty(aDefs[2,i])) ;
      PARENTID cParent ;
      COLOR GRA_CLR_BLACK, GRA_CLR_WHITE SAYLEFTBOTTOM SAYSIZE 0
  ENDIF
  lStatus := .t.
  END SEQUENCE
  IF !lStatus
    @ DCGUI_ROW, DCGUI_COL + 10 DCSAY 'Click here to give this property a value' ;
      COLOR GRA_CLR_RED, GRA_CLR_WHITE SAYLEFTBOTTOM SAYSIZE 60 PARENTID cParent ;
      HYPERLINK _ErrorHyperLinkBlock(oAutomationObject,aDefs[2,i])
  ENDIF
  IF nRow > 22
    IF cParent == 'TAB1'
      cParent := 'TAB2'
    ELSEIF cParent == 'TAB2'
      cParent := 'TAB3'
    ELSEIF cParent == 'TAB3'
      cParent := 'TAB4'
    ENDIF
    nRow := 2
  ENDIF
NEXT

* --- Methods ---
nRow := 2
cParent := 'TAB5'
FOR i := 1 TO Len(aDefs[3])
  nWidth := Max(nWidth,DC_GraQueryTextBox(aDefs[3,i],'8.Helv')[1])
  @ nRow++,2 DCSAY aDefs[3,i] FONT '8.Helv Bold' PARENTID cParent SAYLEFT
  IF nRow > 22
    cParent := 'TAB6'
    nRow := 2
  ENDIF
NEXT

* --- Events ---
nRow := 2
cParent := 'TAB7'
FOR i := 1 TO Len(aDefs[4])
  nWidth := Max(nWidth,DC_GraQueryTextBox(aDefs[4,i],'8.Helv')[1])
  @ nRow++,2 DCSAY aDefs[4,i] + ':' FONT '8.Helv Bold' PARENTID cParent
  lStatus := .f.
  BEGIN SEQUENCE
  @ DCGUI_ROW, DCGUI_COL + 10 ;
      DCSAY DC_XtoC(oAutomationObject:&(aDefs[4,i])) ;
      PARENTID cParent ;
      COLOR GRA_CLR_BLACK, GRA_CLR_WHITE SAYLEFTBOTTOM SAYSIZE 0
  lStatus := .t.
  END SEQUENCE
  IF !lStatus
    @ DCGUI_ROW, DCGUI_COL + 10 DCSAY 'Cannot Display Value (bug in Xbase++)' ;
      COLOR GRA_CLR_RED, GRA_CLR_WHITE SAYLEFTBOTTOM SAYSIZE 0 PARENTID cParent
  ENDIF
  IF nRow > 22
    cParent := 'TAB8'
    nRow := 2
  ENDIF
NEXT

ErrorBlock(bError)

DCGETOPTIONS SAYWIDTH nWidth+40 SAYRIGHTBOTTOM ;
     SAYFONT '10.Lucida Console'

DCREAD GUI FIT TITLE cInterfaceName + ' properties' ;
   MODAL OPTIONS GetOptions SETAPPWINDOW

RETURN .t.

* ----------

STATIC FUNCTION _HyperlinkBlock( oObject )

RETURN {||CJ_DisplayProperties(oObject)}

* ----------

STATIC FUNCTION _ErrorHyperlinkBlock( oObject, cProperty )

RETURN {||ChoosePropertyValue(oObject,cProperty)}

* ----------

STATIC FUNCTION ChoosePropertyValue( oObject, cProperty )

LOCAL GetList[0], nValue := 0, lStatus, xReturn, oError

@ 0,0 DCSAY 'Enter Value' GET nValue PICT '99' SAYSIZE 0 SAYBOTTOM

DCREAD GUI FIT ADDBUTTONS ENTEREXIT ;
   TITLE 'Pass a Value to Property' TO lStatus MODAL

IF lStatus
  oError := ErrorBlock({|e|_TrapError(e)})
  BEGIN SEQUENCE
  xReturn := oObject:getProperty(cProperty,nValue)
  IF Valtype(xReturn) == 'O'
    CJ_DisplayProperties(xReturn)
  ELSE
    DCMSGBOX 'Return value: ' + DC_XtoC(xReturn)
  ENDIF
  END SEQUENCE
  ErrorBlock(oError)
ENDIF

RETURN nil

* -----------

STATIC FUNCTION _TrapError(e)

DC_WinAlert('Invalid Parameter Value')
BREAK

RETURN nil

* -----------

FUNCTION CJ_SetXParent( hWndChild, hWndNewParent )

DllCall( 'User32', DLL_STDCALL, 'SetParent', hWndChild,hWndNewParent)

RETURN NIL

* -----------

FUNCTION CJ_LoadIcon( ncImage, nId, oOwner )

LOCAL i

IF Valtype(oOwner)=='O' .AND. !Empty(ncImage) .AND. !Empty(nID)

  FOR i := 1 TO 10
    IF oOwner:isDerivedFrom('CJ_CommandBars') .OR. ;
       oOwner:isDerivedFrom('CJ_DockingPane')
      oOwner:loadIcon( ncImage, nID)
      EXIT
    ELSEIF oOwner:isDerivedFrom('XbpIwindow')
      EXIT
    ENDIF
    oOwner := oOwner:owner
  NEXT

ENDIF

RETURN nil

* -----------

FUNCTION CJ_SetAppFocus( noXbp )

LOCAL nHandle, nDllHandle

IF Valtype(noXbp) == 'N'
  nHandle := noXbp
ELSEIF Valtype(noXbp) == 'O'
  nHandle := noXbp:getHwnd()
ENDIF

/*
IF Valtype(nHandle) == 'N'
  nDllHandle := DllLoad('ot4xb.dll')
  IF nDllHandle > 0
    &("Delegated_Eval")( {|| &("nFpCall")( {"user32","SetFocus"} , nHandle ) } )
  ELSE
    DC_WinAlert('CJ_SetAppFocus() requires ot4xb.dll')
  ENDIF
ENDIF
*/

SetForeGroundWindow(nHandle)

RETURN nil

* ------------

FUNCTION CJ_TabActivate( oTabControlPage )

oTabControlPage:tabControl:selectedItem := oTabControlPage:index-1

RETURN nil

* -------------

FUNCTION CJ_Empty( x )

RETURN x == nil

* -------------

FUNCTION CJ_IsTrue( x )

RETURN Valtype(x) == 'L' .AND. x

* -------------

FUNCTION CJ_CreateStaticArea( oParent, aGetList )

LOCAL oStatic, Getlist[0], i, oXbp, aChildList, GetOptions, oGetList

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT OBJECT oStatic ;
      SIZE oParent:currentSize()[1], oParent:currentSize()[2] ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCGETOPTIONS RESIZE
DCREAD GUI PARENT oParent EXIT SAVE OPTIONS GetOptions
DC_MergeGetLists( aGetList, GetList )

aChildList := oParent:childList()
oGetList := DC_GetListObject(aGetList)

oStatic:setPos({0,0})
oStatic:setSize(oParent:currentSize())

FOR i := 1 TO Len(aChildList)
  oXbp := aChildList[i]
  IF oXbp:isDerivedFrom("CJ_Parts")
    LOOP
  ELSEIF oXbp == oStatic
    LOOP
  ENDIF
  oXbp:setParent(oStatic)
NEXT

RETURN oStatic

* ------------

FUNCTION CJ_AddAction( oParent, aAction )

LOCAL i, oOwner := oParent:owner

FOR i := 1 TO 10
  IF oOwner:isDerivedFrom('CJ_CommandBars')
    oOwner:addAction(aAction)
    EXIT
  ELSEIF oOwner:isDerivedFrom('XbpIwindow')
    EXIT
  ENDIF
  oOwner := oOwner:owner
NEXT

RETURN nil

* ------------

FUNCTION CJ_AddKeyBinding( oParent, nControl, nKey, nId )

LOCAL i, oOwner := oParent:owner

IF nControl == NIL .OR. nKey == NIL .OR. nId == NIL
  RETURN nil
ENDIF

FOR i := 1 TO 10
  IF oOwner:isDerivedFrom('CJ_CommandBars')
    oOwner:KeyBindings:Add(nControl,nKey,nId)
    EXIT
  ELSEIF oOwner:isDerivedFrom('XbpIwindow')
    EXIT
  ENDIF
  oOwner := oOwner:owner
NEXT

RETURN nil


